/*
inSTREAM Version 4.2, October 2006.
Individual-based stream trout modeling software. Developed and maintained by Steve Railsback (Lang, Railsback & Associates, Arcata, California) and
Steve Jackson (Jackson Scientific Computing, McKinleyville, California).
Development sponsored by EPRI, US EPA, USDA Forest Service, and others.
Copyright (C) 2004 Lang, Railsback & Associates.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program (see file LICENSE); if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
*/



#import <objectbase/SwarmObject.h>
#import <stdlib.h>
#import "ZoneAllocMapper.h"

@interface HabitatSetup: SwarmObject
{

  int habIndex;

  char reachName[50];
  id <Symbol> reachSymbol;
  int habDownStreamJunctionNumber;
  int habUpStreamJunctionNumber;
  char habParamFile[50];

  char cellDataFile[50];
  char flowFile[50];
  char temperatureFile[50];
  char turbidityFile[50];

  char hydraulicsFile1[50];
  char hydraulicsFile2[50];
  char hydraulicsFile3[50];
  char hydraulicsFile4[50];
  char hydraulicsFile5[50];

  id <List> barrierXList;


}

+ createBegin: aZone;
- createEnd;

- setHabitatIndex: (int) anIndex;

- setReachName: (char *) aReachName;
- setReachSymbol: (id <Symbol>) aReachSymbol;
 
- setHabDStreamJNumber: (int) aJunctionNum;
- setHabUStreamJNumber: (int) aJunctionNum;

- setHabParamFile: (char *) aHabParamFile;
- setCellDataFile: (char *) aCellDataFile;
- setFlowFile: (char *) aFlowFile;
- setTemperatureFile: (char *) aTemperatureFile;
- setTurbidityFile: (char *) aTemperatureFile;
- setBarrierXWith: (char *) aBarrierX;

- setHydraulicsFile1: (char *) aHydraulicsFile;
- setHydraulicsFile2: (char *) aHydraulicsFile;
- setHydraulicsFile3: (char *) aHydraulicsFile;
- setHydraulicsFile4: (char *) aHydraulicsFile;
- setHydraulicsFile5: (char *) aHydraulicsFile;



- (char *) getReachName;
- (id <Symbol>) getReachSymbol;

- (int) getHabDStreamJNumber;
- (int) getHabUStreamJNumber;

- (char *) getHabParamFile;
- (char *) getCellDataFile;
- (char *) getFlowFile;
- (char *) getTemperatureFile;
- (char *) getTurbidityFile;
- (id <List>) getBarrierXList;

- (char *) getHydraulicsFile1;
- (char *) getHydraulicsFile2;
- (char *) getHydraulicsFile3;
- (char *) getHydraulicsFile4;
- (char *) getHydraulicsFile5;


@end

