/*
inSTREAM Version 4.2, October 2006.
Individual-based stream trout modeling software. Developed and maintained by Steve Railsback (Lang, Railsback & Associates, Arcata, California) and
Steve Jackson (Jackson Scientific Computing, McKinleyville, California).
Development sponsored by EPRI, US EPA, USDA Forest Service, and others.
Copyright (C) 2004 Lang, Railsback & Associates.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program (see file LICENSE); if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.
*/




#import <math.h>
#import "Vector.h"
@implementation Vector
- (double) getMagnitude {
  int ndx;
  double square;
  double sum=0;
  for (ndx=0;ndx<DIMENSION;ndx++) {
    square = x[ndx]*x[ndx];
    sum += square;
  }
  return sqrt(sum);
}

-minus: aPoint {
  id newVector=nil;
  int ndx;

  newVector = [Vector create: [self getZone]];

  for (ndx=0;ndx<DIMENSION;ndx++) {
    [newVector setElement: ndx 
	       withValue: [self getElement: ndx] - [aPoint getElement: ndx]];
  }
  return newVector;
}


  
-(double) getElement: (int) ordinal {
  return x[ordinal];
}
-setElement: (int) ordinal withValue: (double) aValue {
  x[ordinal] = aValue;
  return self;
}
@end
